UltraSquirt = LibStub("AceAddon-3.0"):NewAddon("UltraSquirt", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "AceHook-3.0")

-- useful global strings:
-- SERVER_MESSAGE_COLON
-- KEYBIND_NOT_SET_TOOLTIP
-- SPELL_FAILED_BAD_TARGETS
-- TARGET
-- ON_COOLDOWN

local USQ = UltraSquirt
USQ.DebugLevel = 0
-- USQ.DebugLevel = 1
-- use 1 for non-spammy stuff and current testing, e.g. response to button click
-- use 2 for common outputs, e.g. interface testing
-- use 3 for very frequent outputs, e.g. once per second
-- use 4 for very spammy stuff like aura update events

USQ.AdvancedTeams = true

USQ.BattleNPCID = 79179
USQ.BattleHealingThreshold = 100
USQ.WaitFlag = false
USQ.WaitTimer = nil

local L = LibStub("AceLocale-3.0"):GetLocale("UltraSquirt")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")

-- Configure NPC list
USQ.npcInfoTimerCount = 0
USQ.npcInfoFoundAll = false
--
USQ.npcInfo = {
-- Warlords Garrison NPCs (excludes those which use the post to start the battles, since it can't be targeted)
    -- Stable Masters
    [79858] = {npcName = nil, canBattle = false, canUseStableMaster = false, custom = false,},  -- Serr'ah
    [85418] = {npcName = nil, canBattle = false, canUseStableMaster = false, custom = false,},  -- Lio the Lioness
    -- Battle NPCs
    [79179] = {npcName = nil, canBattle = true, canUseStableMaster = true, custom = false,},    -- Squirt
    [79751] = {npcName = nil, canBattle = true, canUseStableMaster = true, custom = false,},    -- Eleanor
    [85650] = {npcName = nil, canBattle = true, canUseStableMaster = true, custom = false,},    -- Quintessence of Light
    [85659] = {npcName = nil, canBattle = true, canUseStableMaster = true, custom = false,},    -- The Beakinator
    [85685] = {npcName = nil, canBattle = true, canUseStableMaster = true, custom = false,},    -- Stitches Jr.

    -- Repeatable Legion NPCs    
    [97804] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},   -- Tiffany Nelson
    [98270] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},   -- Robert Craig
    [99077] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},   -- Bredda Tenderhide
    [99150] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},   -- Grixis Tinypop
    [99182] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},   -- Sir Galveston
    [99210] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},   -- Bodhi Sunwayver
    [104553] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Odrogg
    [104970] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Xorvasc
    [105250] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Aulier
    [105386] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Rydyr
    [105387] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Andurs
    [105455] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Trapper Jarrun
    [105674] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Varenne
    [106552] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Nightwatcher Merayl
    [107489] = {npcName = nil, canBattle = true, canUseStableMaster = false, custom = false,},  -- Amalia
}

function USQ:OnInitialize()
    USQ:RegisterChatCommand("ultra", "SlashHandler")

    -- Addon Options
    USQ.defaultOptions = {
        global = {
            KEYBIND = "SPACE",
            AutoSafariHat = true,
            AutoLesserPetTreat = false,
            AutoPetTreat = false,
            AutoReviveBattlePets = true,
            AutoBandage = false,
            BattleHealingThreshold = {['*'] = 100},
            RematchLoadTeamDelay = 10,
            PetBattleCloseDelay = 2,
            HealDelay = 2,
        }
    }
    USQ.db = LibStub("AceDB-3.0"):New("UltraSquirtSettingsDB", USQ.defaultOptions)

    USQ.db.RegisterCallback(USQ, "OnProfileChanged", "RefreshConfig")
    USQ.db.RegisterCallback(USQ, "OnProfileCopied", "RefreshConfig")
    USQ.db.RegisterCallback(USQ, "OnProfileReset", "RefreshConfig")

local options = {
    type = "group",
    args = {
        generalgroup = {
            type = "group",
            name = L["General Settings Group"],
            inline = true,
            order = 10,
            args = {
                keybind = {
                    type = "keybinding",
                    name = KEY_BINDING,
                    --desc = "desc1",
                    set = function(info, val) USQ.db.global.KEYBIND = val end,
                    get = function(info) return USQ.db.global.KEYBIND end,
                    order = 10,
                },
            },
        },
        delaygroup = {
            type = "group",
            name = L["Delay Settings Group"],
            order = 20,
            inline = true,
            args = {
                delaysettingsdescription = {
                    type = "description",
                    fontSize = "medium",
                    name = L["Delay Settings Description"],
                    order = 10,
                },
                rematchloadteamspacer = {
                    type = "description",
                    fontSize = "medium",
                    name = "\n",
                    order = 20,
                },
                rematchloadteamdelay = {
                    type = "range",
                    name = L["Rematch Load Team Delay Setting"],
                    desc = L["Rematch Load Team Delay Description"],
                    min = 1,
                    max = 20,
                    step = 1,
                    set = function(info, val) USQ.db.global.RematchLoadTeamDelay = val end,
                    get = function(info) return USQ.db.global.RematchLoadTeamDelay end,
                    order = 30,
                    width = "double",
                },
                petbattleclosespacer = {
                    type = "description",
                    fontSize = "medium",
                    name = "\n",
                    order = 40,
                },
                petbattleclosedelay = {
                    type = "range",
                    name = L["Pet Battle Close Delay Setting"],
                    desc = L["Pet Battle Close Delay Description"],
                    min = 1,
                    max = 20,
                    step = 1,
                    set = function(info, val) USQ.db.global.PetBattleCloseDelay = val end,
                    get = function(info) return USQ.db.global.PetBattleCloseDelay end,
                    order = 50,
                    width = "double",
                },
                healdelayspacer = {
                    type = "description",
                    fontSize = "medium",
                    name = "\n",
                    order = 60,
                },
                healdelay = {
                    type = "range",
                    name = L["Heal Delay Setting"],
                    desc = L["Heal Delay Description"],
                    min = 1,
                    max = 20,
                    step = 1,
                    set = function(info, val) USQ.db.global.HealDelay = val end,
                    get = function(info) return USQ.db.global.HealDelay end,
                    order = 70,
                    width = "double",
                },
            },
        },
    },
}

    AceConfig:RegisterOptionsTable("UltraSquirt", options)
    AceConfigDialog:AddToBlizOptions("UltraSquirt")

    -- Frame Setup
    if USQ.Frame == nil then
        USQ.Frame = CreateFrame("Frame", "UltraSquirtFrame", UIParent)
    end
    USQ.Frame:Hide()
    -- any changes here need to be appled in the reset option for SlashHandler too
    USQ.Frame:ClearAllPoints()
    USQ.Frame:SetPoint("TOP", "UIParent", "TOP", 0, -225)
    USQ.Frame:SetWidth(280)
    USQ.Frame:SetHeight(195)
    USQ.Frame:SetFrameStrata("DIALOG")
    USQ.Frame:SetMovable(true)
    USQ.Frame:EnableMouse(true)
    USQ.Frame:SetClampedToScreen(true)
    -- movement hanlders are set on TitleButton below

    local TitleBG = USQ.Frame:CreateTexture("TitleBG", "BACKGROUND")
    TitleBG:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Title-Background")
    TitleBG:SetPoint("TOPLEFT", 9, -6)
    TitleBG:SetPoint("BOTTOMRIGHT", USQ.Frame, "TOPRIGHT", -28, -24)

    local DialogBG = USQ.Frame:CreateTexture("DialogBG", "BACKGROUND")
    DialogBG:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
    DialogBG:SetPoint("TOPLEFT", 8, -24)
    DialogBG:SetPoint("BOTTOMRIGHT", -6, 8)
    DialogBG:SetColorTexture(0, 0, 0, .75)

    local TopLeft = USQ.Frame:CreateTexture("TopLeft", "BORDER")
    TopLeft:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    TopLeft:SetPoint("TOPLEFT")
    TopLeft:SetWidth(64)
    TopLeft:SetHeight(64)
    TopLeft:SetTexCoord(0.501953125, 0.625, 0, 1)

    local TopRight = USQ.Frame:CreateTexture("TopRight", "BORDER")
    TopRight:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    TopRight:SetPoint("TOPRIGHT")
    TopRight:SetWidth(64)
    TopRight:SetHeight(64)
    TopRight:SetTexCoord(0.625, 0.75, 0, 1)

    local Top = USQ.Frame:CreateTexture("Top", "BORDER")
    Top:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Top:SetPoint("TOPLEFT", TopLeft, "TOPRIGHT")
    Top:SetPoint("TOPRIGHT", TopRight, "TOPLEFT")
    Top:SetWidth(0)
    Top:SetHeight(64)
    Top:SetTexCoord(0.25, 0.369140625, 0, 1)

    local BottomLeft = USQ.Frame:CreateTexture("BottomLeft", "BORDER")
    BottomLeft:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    BottomLeft:SetPoint("BOTTOMLEFT")
    BottomLeft:SetWidth(64)
    BottomLeft:SetHeight(64)
    BottomLeft:SetTexCoord(0.751953125, 0.875, 0, 1)

    local BottomRight = USQ.Frame:CreateTexture("BottomRight", "BORDER")
    BottomRight:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    BottomRight:SetPoint("BOTTOMRIGHT")
    BottomRight:SetWidth(64)
    BottomRight:SetHeight(64)
    BottomRight:SetTexCoord(0.875, 1, 0, 1)

    local Bottom = USQ.Frame:CreateTexture("Bottom", "BORDER")
    Bottom:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Bottom:SetPoint("BOTTOMLEFT", BottomLeft, "BOTTOMRIGHT")
    Bottom:SetPoint("BOTTOMRIGHT", BottomRight, "BOTTOMLEFT")
    Bottom:SetWidth(0)
    Bottom:SetHeight(64)
    Bottom:SetTexCoord(0.376953125, 0.498046875, 0, 1)

    local Left = USQ.Frame:CreateTexture("Left", "BORDER")
    Left:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Left:SetPoint("TOPLEFT", TopLeft, "BOTTOMLEFT")
    Left:SetPoint("BOTTOMLEFT", BottomLeft, "TOPLEFT")
    Left:SetWidth(64)
    Left:SetHeight(0)
    Left:SetTexCoord(0.001953125, 0.125, 0, 1)

    local Right = USQ.Frame:CreateTexture("Bottom", "BORDER")
    Right:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-Border")
    Right:SetPoint("TOPRIGHT", TopRight, "BOTTOMRIGHT")
    Right:SetPoint("BOTTOMRIGHT", BottomRight, "TOPRIGHT")
    Right:SetWidth(64)
    Right:SetHeight(0)
    Right:SetTexCoord(0.1171875, 0.2421875, 0, 1)

    local CloseButton = CreateFrame("Button", "UltraSquirtCloseButton", USQ.Frame, "UIPanelCloseButton")
    CloseButton:SetPoint("TOPRIGHT", 2, 1)
    CloseButton:SetWidth(32)
    CloseButton:SetHeight(32)
    CloseButton:SetScript("OnClick", USQ.Close)

    local TitleButton = CreateFrame("Button", "TitleButton", USQ.Frame)
    TitleButton:SetPoint("TOPLEFT", TitleBG, "TOPLEFT")
    TitleButton:SetPoint("TOPRIGHT", TitleBG, "TOPRIGHT")
    TitleButton:SetWidth(375)
    TitleButton:SetHeight(16)
    TitleButton:RegisterForDrag("LeftButton")
    TitleButton:SetScript("OnDragStart", function(self) local parent = self:GetParent() parent.moving = true parent:StartMoving() end)
    TitleButton:SetScript("OnDragStop", function(self) local parent = self:GetParent() parent.moving = nil parent:StopMovingOrSizing() end)
    
    local TitleButtonText = TitleButton:CreateFontString("Text", "OVERLAY", "GameFontNormal")
    TitleButtonText:SetPoint("TOPLEFT", TitleButton, "TOPLEFT")
    TitleButtonText:SetPoint("TOPRIGHT", TitleButton, "TOPRIGHT")
    TitleButtonText:SetWidth(375)
    TitleButtonText:SetHeight(16)
    TitleButtonText:SetText("UltraSquirt")

    USQ.Frame.MacroButton = CreateFrame("Button", "UltraSquirtButton", USQ.Frame, "InsecureActionButtonTemplate")
    USQ.Frame.MacroButton:SetAttribute("type1", "macro")

    USQ.Frame.MacroButton:SetText("Ultra")
    USQ.Frame.MacroButton:HookScript("OnClick", USQ.Update)
    USQ.Frame:SetScript("OnKeyDown", USQ.Update)
    USQ.Frame:SetPropagateKeyboardInput(true)

    USQ.Frame.SafariHatButton = USQ.ButtonFactory(USQ.Frame, "ItemButton", "SafariHatButton", "toy", 92738, true, true, "AutoSafariHat")
    USQ.Frame.LesserPetTreatButton = USQ.ButtonFactory(USQ.Frame, "ItemButton", "LesserPetTreatButton", "item", 98112, true, false, "AutoLesserPetTreat")
    USQ.Frame.PetTreatButton = USQ.ButtonFactory(USQ.Frame, "ItemButton", "PetTreatButton", "item", 98114, true, false, "AutoPetTreat")
    USQ.Frame.ReviveBattlePetsButton = USQ.ButtonFactory(USQ.Frame, "ItemButton", "ReviveBattlePetsButton", "spell", 125439, true, true, "AutoReviveBattlePets")
    USQ.Frame.BandageButton = USQ.ButtonFactory(USQ.Frame, "ItemButton", "BandageButton", "item", 86143, true, true, "AutoBandage")

    USQ.Frame.SetBattleNPCButton = CreateFrame("Button", USQ.Frame:GetName() .. "SetBattleNPCButton", USQ.Frame)
    USQ.Frame.SetBattleNPCButton:SetWidth(32)
    USQ.Frame.SetBattleNPCButton:SetHeight(32)
    USQ.Frame.SetBattleNPCButton.icon = USQ.Frame.SetBattleNPCButton:CreateTexture(USQ.Frame.SetBattleNPCButton:GetName() .. "IconTexture", "BORDER")
    USQ.Frame.SetBattleNPCButton.icon:SetAllPoints(USQ.Frame.SetBattleNPCButton)
    USQ.Frame.SetBattleNPCButton.icon:SetTexture("Interface\\Cursor\\Crosshairs")
    USQ.Frame.SetBattleNPCButton.IconBorder = USQ.Frame.SetBattleNPCButton:CreateTexture(nil, "OVERLAY")
    USQ.Frame.SetBattleNPCButton.IconBorder:SetHeight(37)
    USQ.Frame.SetBattleNPCButton.IconBorder:SetWidth(37)
    USQ.Frame.SetBattleNPCButton.IconBorder:SetPoint("CENTER", USQ.Frame.SetBattleNPCButton, "CENTER")
    USQ.Frame.SetBattleNPCButton.IconBorder:SetTexture("Interface\\Common\\WhiteIconFrame")

    --ref C:\Games\World of Warcraft\_retail_\BlizzardInterfaceCode\Interface\FrameXML\ItemButtonTemplate.xml line #73
    USQ.Frame.SetBattleNPCButton.NormalTexture = USQ.Frame.SetBattleNPCButton:CreateTexture(USQ.Frame.SetBattleNPCButton:GetName() .. "NormalTexture", "Interface\\Buttons\\UI-Quickslot2")
    USQ.Frame.SetBattleNPCButton.NormalTexture:SetWidth(64)
    USQ.Frame.SetBattleNPCButton.NormalTexture:SetHeight(64)
    USQ.Frame.SetBattleNPCButton.NormalTexture:SetPoint("CENTER", USQ.Frame.SetBattleNPCButton, 0, -1)
    USQ.Frame.SetBattleNPCButton:SetNormalTexture(USQ.Frame.SetBattleNPCButton.NormalTexture)
    USQ.Frame.SetBattleNPCButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress")
    USQ.Frame.SetBattleNPCButton:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square", "ADD")
    USQ.Frame.SetBattleNPCButton:SetScript("OnClick", USQ.SetBattleNPCButton_OnClick)

    USQ.Frame.BattleNPCFontString = USQ.Frame:CreateFontString(USQ.Frame:GetName() .. "BattleNPCFontString", "OVERLAY", "GameFontWhite", 0)
    USQ.Frame.BattleNPCFontString:SetWordWrap(true)
    USQ.Frame.BattleNPCFontString:SetJustifyH("LEFT")
    USQ.Frame.BattleNPCFontString:SetWidth(188)
    USQ.Frame.BattleNPCFontString:SetHeight(32)

    --ref: C:\Games\World of Warcraft\_retail_\BlizzardInterfaceCode\Interface\SharedXML\VideoOptionsPanels.xml  #344
    USQ.Frame.BattleHealingThresholdSlider = CreateFrame("Slider", USQ.Frame:GetName() .. "BattleHealingThresholdSlider", USQ.Frame, "HorizontalSliderTemplate")
    USQ.Frame.BattleHealingThresholdSlider:SetWidth(240)
    USQ.Frame.BattleHealingThresholdSlider:SetHeight(16)
    USQ.Frame.BattleHealingThresholdSlider:SetObeyStepOnDrag(true)
    USQ.Frame.BattleHealingThresholdSlider:SetMinMaxValues(0, 100)
    USQ.Frame.BattleHealingThresholdSlider:SetValueStep(5)
    USQ.Frame.BattleHealingThresholdSlider.Title = USQ.Frame.BattleHealingThresholdSlider:CreateFontString(USQ.Frame.BattleHealingThresholdSlider:GetName() .. "Title", "ARTWORK", "OptionsFontHighlight", 0)
    USQ.Frame.BattleHealingThresholdSlider.Title:SetPoint("BOTTOMLEFT", USQ.Frame.BattleHealingThresholdSlider, "TOPLEFT", 0, 2)
    USQ.Frame.BattleHealingThresholdSlider.Title:SetText(_G["MINIMUM"] .. " " .. _G["HP"])
    USQ.Frame.BattleHealingThresholdSlider.displayValue = USQ.Frame.BattleHealingThresholdSlider:CreateFontString(nil, "ARTWORK", "OptionsFontLarge", 0)
    USQ.Frame.BattleHealingThresholdSlider.displayValue:SetJustifyH("CENTER")
    USQ.Frame.BattleHealingThresholdSlider.displayValue:SetPoint("CENTER", USQ.Frame.BattleHealingThresholdSlider, "CENTER", 0, 18)
    USQ.Frame.BattleHealingThresholdSlider:SetScript("OnValueChanged", USQ.BattleHealingThresholdSlider_OnValueChanged)
    USQ.Frame.BattleHealingThresholdSlider:SetValue(USQ.db.global.BattleHealingThreshold[USQ.BattleNPCID])
    -- USQ.BattleHealingThresholdSlider_SetDisplayValue(USQ.Frame.BattleHealingThresholdSlider:GetValue())

    USQ.Frame.HotkeyFontString = USQ.Frame:CreateFontString("UltraSquirtFrameHotkeyFontString", "OVERLAY", "GameFontWhite", 0)
    USQ.Frame.HotkeyFontString:SetWordWrap(false)
    USQ.Frame.HotkeyFontString:SetWidth(240)
    USQ.Frame.HotkeyFontString:SetHeight(16)

    USQ.Frame.SafariHatButton:SetPoint("TOPLEFT", 22, -44)
    USQ.Frame.LesserPetTreatButton:SetPoint("LEFT", USQ.Frame.SafariHatButton, "RIGHT", 20, 0)
    USQ.Frame.PetTreatButton:SetPoint("LEFT", USQ.Frame.LesserPetTreatButton, "RIGHT", 20, 0)
    USQ.Frame.ReviveBattlePetsButton:SetPoint("LEFT", USQ.Frame.PetTreatButton, "RIGHT", 20, 0)
    USQ.Frame.BandageButton:SetPoint("LEFT", USQ.Frame.ReviveBattlePetsButton, "RIGHT", 20, 0)

    USQ.Frame.SetBattleNPCButton:SetPoint("TOPLEFT", USQ.Frame.SafariHatButton, "BOTTOMLEFT", 0, -10)
    USQ.Frame.BattleNPCFontString:SetPoint("LEFT", USQ.Frame.SetBattleNPCButton, "RIGHT", 20, 0)

    USQ.Frame.BattleHealingThresholdSlider:SetPoint("TOPLEFT", USQ.Frame.SetBattleNPCButton, "BOTTOMLEFT", 0, -25)

    USQ.Frame.HotkeyFontString:SetPoint("TOPLEFT", USQ.Frame.BattleHealingThresholdSlider, "BOTTOMLEFT", 0, -5)

    -- Revive and Bandage button pre/post click
    USQ.Frame.ReviveBattlePetsButton:SetScript("PreClick", USQ.BandageHealPreClick)
    USQ.Frame.ReviveBattlePetsButton:SetScript("PostClick", USQ.BandageHealPostClick)
    USQ.Frame.BandageButton:SetScript("PreClick", USQ.BandageHealPreClick)
    USQ.Frame.BandageButton:SetScript("PostClick", USQ.BandageHealPostClick)

    -- Final setup
    USQ:PopulateNPCInfo()
    -- USQ:UpdateBattleNPC(USQ.BattleNPCID)

    -- Rematch specifics
    if Rematch then
        USQ.Debug(1, "Rematch already loaded - running hook function")
        USQ:HookRematchLoadHealthiestOfLoadedPets()
    else
        USQ:RegisterEvent("ADDON_LOADED")
    end
end

function USQ:ADDON_LOADED(eventName, addOnName)
    if addOnName == "Rematch" then
        USQ.Debug(1, "Rematch now loaded - running hook function.")
        USQ:HookRematchLoadHealthiestOfLoadedPets()
        USQ:UnregisterEvent("ADDON_LOADED")
    end
end

function USQ:HookRematchLoadHealthiestOfLoadedPets()
    USQ.Debug(1, "Hooking to Rematch:LoadHealthiestOfLoadedPets.")
    USQ:SecureHook(Rematch, "LoadHealthiestOfLoadedPets", "RematchLoadHealthiestOfLoadedPetsHandler")
end

function USQ:RematchLoadHealthiestOfLoadedPetsHandler()
    USQ.Debug(1, "Running handler for hook to Rematch:LoadHealthiestOfLoadedPets.")
    local TimeRemaining = USQ:TimeLeft(USQ.WaitTimer)
    if TimeRemaining > 0 then
        USQ.Debug(1, "Setting WaitFlag = false, cancelling timer with " .. tostring(TimeRemaining) .. "s left.")
        USQ:CancelTimer(USQ.WaitTimer)
    else
        USQ.Debug(1, "Setting WaitFlag = false, timer already expired.")
    end
    USQ.WaitFlag = false
end

-- ref: https://wow.gamepedia.com/UIOBJECT_GameTooltip
-- /dump UltraSquirt:GetNPCName(12345)
function USQ:GetNPCName(npcID)
    USQ.Debug(2, "Running GetNPCName")
    USQ.Debug(2, "npcID: " .. tostring(npcID))

    if USQ.npcInfo[npcID] and USQ.npcInfo[npcID].npcName then
        USQ.Debug(2, "NPC found in USQ.npcInfo - returning result from table.  npcName: " .. USQ.npcInfo[npcID].npcName)
        return USQ.npcInfo[npcID].npcName
    end

    if not USQ.ScanningTooltip then
        USQ.ScanningTooltip = CreateFrame("GameTooltip", "UltraSquirtScanningTooltip", USQ.Frame, "GameTooltipTemplate")
    end
    USQ.ScanningTooltip:SetOwner(USQ.Frame, "ANCHOR_NONE")
    USQ.ScanningTooltip:SetHyperlink(format("unit:Creature-0-0-0-0-%s-0000000000", npcID))
    USQ.Debug(2, "string: " .. format("unit:Creature-0-0-0-0-%s-0000000000", npcID))
    USQ.Debug(2, "NumLines: " .. tostring(UltraSquirtScanningTooltip:NumLines()))

    local npcName
    if USQ.ScanningTooltip:NumLines() >= 1 then
        npcName = UltraSquirtScanningTooltipTextLeft1:GetText()
        USQ.Debug(2, "npcName: " .. npcName)
        return npcName
    end
    USQ.Debug(2, "npcName: not found")
end

-- /dump UltraSquirt:PopulateNPCInfo()
-- run this on initialise
function USQ:PopulateNPCInfo()
    USQ.Debug(2, "Running PopulateNPCInfo")
    local FoundAll = true
    for npcID, npcDetails in pairs(USQ.npcInfo) do
        if npcDetails.npcName == nil then
            npcDetails.npcName = USQ:GetNPCName(npcID)
        end
        FoundAll = FoundAll and (npcDetails.npcName ~= nil)
        USQ.Debug(2, "npcID: " .. tostring(npcID) .. " npcDetails.npcName: " .. tostring(npcDetails.npcName) .. " npcDetails.canBattle: " .. tostring(npcDetails.canBattle))
    end
    USQ.Debug(2, "FoundAll: " .. tostring(FoundAll))

    if not FoundAll then
        if USQ.npcInfoTimerCount < 5 then
            USQ.npcInfoTimerCount = USQ.npcInfoTimerCount + 1
            USQ.PopulateNPCInfoTimer = USQ:ScheduleTimer("PopulateNPCInfo", 5)
            USQ.Debug(2, "Started timer to rerun PopulateNPCInfo.  USQ.npcInfoTimerCount: " .. tostring(USQ.npcInfoTimerCount))
        else
            USQ.Debug(2, "Max runs reached for PopulateNPCInfo.  USQ.npcInfoTimerCount: " .. tostring(USQ.npcInfoTimerCount))
        end
    end

    USQ.npcInfoFoundAll = FoundAll
    USQ:UpdateBattleNPC(USQ.BattleNPCID)
    return FoundAll
end

function USQ.SetBattleNPCButton_OnClick(button, buttonClicked, down)
    USQ.Debug(1, "button: " .. tostring(button:GetName()) .. " buttonClicked: " .. tostring(buttonClicked) .. " down: " .. tostring(down))
    -- ???????? can the button be set to glow when target is not the currently saved one, but canBattle = true?
    if InCombatLockdown() then
        USQ.Debug(1, "In combat - take no action")
    else
        if C_PetBattles.IsInBattle() then
            USQ.Debug(1, "In pet battle - take no action")
            USQ:Print(L["Cannot Modify In Battle"])
        else
            local npcID = USQ:TargetNPCID()
            if npcID and USQ.npcInfo[npcID] and USQ.npcInfo[npcID].canBattle then
                USQ:UpdateBattleNPC(npcID)
                USQ.Update()
            else
                USQ:Print(L["Invalid Target"])
            end
        end
    end
end

function USQ:UpdateBattleNPC(npcID)
    USQ.Debug(1, "Running UpdateBattleNPC")
    USQ.Debug(1, "Updating Battle NPC to: npcID: " .. tostring(npcID) .. " npcName: " .. (USQ:GetNPCName(npcID) or "nil"))
    USQ.BattleNPCID = npcID
    USQ.Frame.BattleNPCFontString:SetText(_G["TARGET"] .. ": " .. (USQ:GetNPCName(npcID) or "nil"))
    USQ.Frame.BattleHealingThresholdSlider:SetValue(USQ.db.global.BattleHealingThreshold[USQ.BattleNPCID])
end

function USQ.BattleHealingThresholdSlider_SetDisplayValue(value)
    USQ.Debug(1, "Updating Battle Healing Theshold Slider Display Value: " .. tostring(value))
    USQ.Frame.BattleHealingThresholdSlider.displayValue:SetText(tostring(value) .. "%")
end

function USQ.BattleHealingThresholdSlider_OnValueChanged(self, value, userInput)
    USQ.Debug(1, "Running Slider_OnValueChanged")
    USQ.Debug(1, "Slider_OnValueChanged: value: " .. tostring(value) .. " userInput: " .. tostring(userInput))
    USQ.BattleHealingThresholdSlider_SetDisplayValue(value)
    USQ.db.global.BattleHealingThreshold[USQ.BattleNPCID] = value
end

function USQ:RefreshConfig()
    USQ.Debug(1, "Profile refresh detected.  Running UpdateKeybind().")
    USQ.UpdateKeybind()
    USQ.Frame.BattleHealingThresholdSlider:SetValue(USQ.db.global.BattleHealingThreshold[USQ.BattleNPCID])
end

function USQ.UpdateKeybind()
    if USQ.db.global.KEYBIND == nil or USQ.db.global.KEYBIND == "" then
        USQ.Frame.HotkeyFontString:SetText("<" .. L["Keybind Missing"] .. ">")
    else
        USQ.Frame.HotkeyFontString:SetText("<" .. USQ.db.global.KEYBIND .. ">")
    end    
end

function USQ.ButtonFactory(parentFrame, buttonType, buttonName, type1, actionID, isTogglable, autoCastAllowed, autoCastOption)
    local button = CreateFrame(buttonType, parentFrame:GetName() .. buttonName, parentFrame, "InsecureActionButtonTemplate")

    button.actionID = actionID
    button.type1 = type1

    button:SetWidth(32)
    button:SetHeight(32)
    button:SetAttribute("type1", type1)
    if type1 == "item" then
        button.actionString = "item:" .. tostring(actionID)
        button:SetAttribute("item", button.actionString)
        button.icon:SetTexture(GetItemIcon(actionID))
    elseif type1 == "toy" then
        button.actionString = tostring(actionID)
        button:SetAttribute("toy", button.actionString)
        button.icon:SetTexture(GetItemIcon(actionID))
    elseif type1 == "spell" then
        button.actionString = tostring(actionID)
        button:SetAttribute("spell", button.actionString)
        button.icon:SetTexture(GetSpellTexture(actionID))
    end
    
    button.cooldown = CreateFrame("Cooldown", parentFrame:GetName() .. buttonName .. "Cooldown", button, "CooldownFrameTemplate")
    button.cooldown:SetAllPoints()
    button.cooldown:SetSwipeColor(1, 1, 1, .8)
    button.cooldown:Hide()

    button.AutoCastableTexture = button:CreateTexture(parentFrame:GetName() .. buttonName .. "AutoCastableTexture", "OVERLAY")
    button.AutoCastableTexture:SetTexture("Interface\\Buttons\\UI-AutoCastableOverlay")
    button.AutoCastableTexture:SetPoint("CENTER", button, "CENTER", 0, 0)
    button.AutoCastableTexture:SetWidth(62)
    button.AutoCastableTexture:SetHeight(62)
    
    if autoCastAllowed == true then
        button.AutoCastableTexture:Show()
        button.autoCastAllowed = true
    else
        button.AutoCastableTexture:Hide()
        button.autoCastAllowed = false
    end

    if isTogglable == true then
        button.isTogglable = true
    else
        button.isTogglable = false
    end

    button.Shine = CreateFrame("Frame", parentFrame:GetName() .. buttonName .. "Shine", button, "AutoCastShineTemplate")
    button.Shine:SetPoint("CENTER", button, "CENTER", 0, 0)
    button.Shine:SetWidth(32)
    button.Shine:SetHeight(32)
    
    button.autoCastOption = autoCastOption
        
    button:SetScript("OnShow", function(self)
        button:RegisterEvent("BAG_UPDATE")
        button:RegisterEvent("NEW_TOY_ADDED")
        button:RegisterEvent("PLAYER_ENTERING_WORLD")
        button:RegisterEvent("SPELL_UPDATE_COOLDOWN")
        button:RegisterEvent("TOYS_UPDATED")
        button:RegisterEvent("UNIT_AURA")
        button:RegisterEvent("UNIT_INVENTORY_CHANGED")
        button:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
        
        USQ.ItemButton_UpdateCooldown(button)
        USQ.ItemButton_UpdateCount(button)
        USQ.ItemButton_UpdateState(button)
    end)
    button:SetScript("OnHide", function(self) button:UnregisterAllEvents() end)
    button:SetScript("OnEvent", USQ.ItemButton_OnEvent)
    button:HookScript("OnClick", USQ.ItemButton_OnClick)

    return button
end

function USQ:OnEnable()
    USQ:Print(L["Addon Enabled"])
end

function USQ:OnDisable()
    USQ.Close()
    USQ:Print(L["Addon Disabled"])
end

function USQ.Debug(DebugLevel, ...)
    if DebugLevel <= USQ.DebugLevel then
        USQ:Print(...)
    end
end

function USQ.SetMacro(macroText)
    if not InCombatLockdown() then
        USQ.Debug(2, "Setting macro to " .. tostring(macroText))
        USQ.Frame.MacroButton:SetAttribute("macrotext1", macroText)
    end
end

function USQ:SlashHandler(input)
    local arg1 = USQ:GetArgs(input, 1, 1)
    if arg1 and string.lower(arg1) == "config" then
        AceConfigDialog:Open("UltraSquirt")
    elseif arg1 and string.lower(arg1) == "reset" then
        USQ:ResetOptions()
    elseif USQ.Frame:IsShown() then
        USQ.Close()
    else
        USQ.Open()
    end
end

function USQ:ResetOptions()
    USQ.Debug(1, "Running ResetOptions:")
    if not InCombatLockdown() then
        USQ.Debug(1, "Not in combat lockdown")
        -- run reset
        USQ:Print(L["Resetting Options"])
        USQ.Close()
        USQ.db:ResetDB("Default")
        USQ.Frame:ClearAllPoints()
        USQ.Frame:SetPoint("TOP", "UIParent", "TOP", 0, -225)
        USQ.Frame:SetWidth(280)
        USQ.Frame:SetHeight(195)
        USQ.Frame:SetFrameStrata("DIALOG")
        USQ.Open()
        -- Refresh any open options windows
        AceConfigRegistry:NotifyChange("UltraSquirt")
        -- clear flag and timer
        USQ.ResetOptionsAwaitingOOC = false
        USQ:CancelTimer(USQ.ResetOptionsOOCTimer)
    else
        if not(USQ.ResetOptionsAwaitingOOC) then
            USQ:Print(L["Resetting Options OOC"])
        end
        USQ.ResetOptionsAwaitingOOC = true
        USQ.ResetOptionsOOCTimer = USQ:ScheduleTimer("ResetOptions", 1)
    end
end

function USQ.Close()
    USQ.Debug(1, "Close: Combat Lockdown:" .. tostring(InCombatLockdown()))
    SetCVar("AutoInteract", 0)
    if not InCombatLockdown() then
        ClearOverrideBindings(USQ.Frame)
    end
    USQ:CancelAllTimers()
    -- USQ:UnregisterAllEvents()
    USQ:UnregisterEvent("PET_BATTLE_OPENING_START")
    USQ:UnregisterEvent("PET_BATTLE_CLOSE")
    USQ:UnregisterEvent("GOSSIP_SHOW")
    USQ:UnregisterEvent("PLAYER_REGEN_DISABLED")
    USQ.Frame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    USQ.Frame:EnableKeyboard(false)
    USQ.Frame:Hide()
    USQ.Debug(1, "Frame hidden")
end

function USQ.Open()
    USQ.Frame:Show()
    USQ.Debug(1, "Frame shown")
    USQ:RegisterEvent("PET_BATTLE_OPENING_START")
    USQ:RegisterEvent("PET_BATTLE_CLOSE")
    USQ:RegisterEvent("GOSSIP_SHOW")
    USQ:RegisterEvent("PLAYER_REGEN_DISABLED")
    USQ.Frame:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", "player")
    USQ.Frame:SetScript("OnEvent", USQ.UNIT_SPELLCAST_SUCCEEDED)
    USQ.Frame:EnableKeyboard(true)
    USQ.Update()
    USQ.UpdateTimer = USQ:ScheduleRepeatingTimer("Update", 1)
    USQ.UpdateKeybind()
end

function USQ.EventHandler(eventName)
    USQ.Debug(3, "Event: " .. (eventName or ""))
    if eventName == "PLAYER_REGEN_DISABLED" then
        USQ.Close()
    elseif (eventName == "PET_BATTLE_OPENING_START" or eventName == "PET_BATTLE_OVER" or "PET_BATTLE_CLOSE" or eventName == "PET_JOURNAL_LIST_UPDATE") then
        USQ.Update()
    else
        USQ.Debug(3, "Unknown Event: " .. (eventName or ""))
    end
end

function USQ.Update()
    -- runs when registered events are triggered, after certain event, on button clicks, and on a timer
    USQ.Debug(2, "Running Update")
    local hotkey = USQ.db.global.KEYBIND
    local BattleNPCName = USQ:GetNPCName(USQ.BattleNPCID)
    local StableMasterSerrahNPCName = USQ:GetNPCName(79858)
    local StableMasterLioNPCName = USQ:GetNPCName(85418)

    USQ.UpdateKeybind()

    if InCombatLockdown() then
        USQ.Debug(2, "In combat - take no action")
    elseif hotkey == nil then
        USQ.Debug(2, "Hotkey not set - take no action")
    else
        if C_PetBattles.IsInBattle() then
            -- In pet battle
            USQ.Debug(2, "In pet battle - setting hotkey to /click for TD Script auto button.  Disable IWT and CTM.")
            SetCVar("AutoInteract", 0)
            ClearOverrideBindings(USQ.Frame)
            SetOverrideBindingClick(USQ.Frame, true, hotkey, "tdBattlePetScriptAutoButton")
        else
            USQ.Debug(2, "Checking for pet damage")
            local npcID = USQ:TargetNPCID()
            if Rematch then
                if Rematch:IsTimerRunning("ReloadLoadIn") or Rematch:IsTimerRunning("TeamlessReloadLoadIn") then
                    USQ.Debug(1, "Rematch is loaded, and is current loading a team.  Doing nothing until next update.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    USQ.SetMacro("/target player")
                    SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                    return
                end
            end
            if USQ.WaitFlag then
                USQ.Debug(1, "WaitFlag = true.  Wait for flag to time out, or Rematch to load a new team.")
                SetCVar("AutoInteract", 0)
                ClearOverrideBindings(USQ.Frame)
                USQ.SetMacro("/target player")
                SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                return
            end
            if USQ:PetsHurt(USQ.db.global.BattleHealingThreshold[USQ.BattleNPCID]) then
                -- Pets need healed
                if (USQ.db.global.AutoReviveBattlePets == true and GetSpellCooldown(125439) == 0 and IsSpellKnown(125439)) then
                    USQ.Debug(2, "Pets damaged or below threshold, Revive Battle Pets known and off CD.  Set button to /cast Revive Battle Pets.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    -- USQ.SetMacro("/cast " .. GetSpellInfo(125439))
                    USQ.SetMacro("/click UltraSquirtFrameReviveBattlePetsButton")
                    SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                elseif USQ.db.global.AutoBandage == true and GetItemCount(86143, false) > 0 and GetItemInfo(86143) then
                    -- included GetItemInfo(86143) in if just in case it returns nil (i.e. item details not yet in cache), which should also mean there are none in the inventory
                    USQ.Debug(2, "Pets damaged or below threshold, Revive Battle Pets disabled or on CD.  Set button to /use Battle Pet Bandage.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    -- USQ.SetMacro("/use " .. (GetItemInfo(86143)))
                    USQ.SetMacro("/click UltraSquirtFrameBandageButton")
                    SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                elseif USQ.npcInfo[USQ.BattleNPCID].canUseStableMaster then
                    USQ.Debug(2, "Pets damaged or below threshold, Revive Battle Pets disabled or on CD, Bandages disabled or none left, and fighting Garrison NPC, so use Stable Master to heal.")
                    if GossipFrame:IsShown() and (GossipFrameNpcNameText:GetText() == StableMasterLioNPCName or GossipFrameNpcNameText:GetText() == StableMasterSerrahNPCName) then
                        USQ.Debug(2, "Running Squirt healing logic.  Gossip window open and NPC matches.  Select gossip option.")
                        SetCVar("AutoInteract", 0)
                        ClearOverrideBindings(USQ.Frame)
                        C_GossipInfo.SelectOption(1, "", true)
                    elseif (npcID == 85418 or npcID == 79858) then
                        USQ.Debug(2, "Pets damaged, target is Stable Master.  Set button to IWT and enable CTM.")
                        SetCVar("AutoInteract", 1)
                        ClearOverrideBindings(USQ.Frame)
                        SetOverrideBinding(USQ.Frame, true, hotkey, "INTERACTTARGET")
                    else
                        USQ.Debug(2, "Pets damaged, set macro to /target Stable Master.  Disable IWT and CTM.")
                        SetCVar("AutoInteract", 0)
                        ClearOverrideBindings(USQ.Frame)
                        USQ.SetMacro("/targetexact " .. StableMasterLioNPCName .. "\n/targetexact " .. StableMasterSerrahNPCName)
                        SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                    end
                else
                    -- no action to take
                    USQ.Debug(2, "Pets damaged or below threshold, Revive Battle Pets and Bandage both disabled, on cooldown, or ran out.  Doing nothing...")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    USQ.SetMacro("/target player")
                    SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                end
            else
                -- Pets OK - get ready for battle
                if PlayerHasToy(92738) and AuraUtil.FindAuraByName((GetItemSpell(92738)), "player") == nil and USQ.db.global.AutoSafariHat then
                    USQ.Debug(2, "Pets not damaged or above threshold, player has Safari Hat toy, and buff is missing.  Set macro to /use Safari Hat.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    local toyName = (select(2, C_ToyBox.GetToyInfo(92738)))
                    if toyName == nil or string.len(toyName) == 0 then
                        USQ.Debug(2, "Safari Hat toy info not found.  Wait for next update.  Doing nothing...")
                        SetCVar("AutoInteract", 0)
                        ClearOverrideBindings(USQ.Frame)
                        USQ.SetMacro("/target player")
                        SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                        return
                    else
                        USQ.SetMacro("/use " .. toyName)
                        SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                    end
                elseif GossipFrame:IsShown() and GossipFrameNpcNameText:GetText() == BattleNPCName then
                    USQ.Debug(2, "Pets not damaged or above threshold, Gossip window open and NPC matches.  Select gossip option.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    C_GossipInfo.SelectOption(1, "", true)
                elseif (npcID == USQ.BattleNPCID) then
                    USQ.Debug(2, "Pets not damaged or above threshold, target matches.  Set button to IWT and enable CTM.")
                    SetCVar("AutoInteract", 1)
                    ClearOverrideBindings(USQ.Frame)
                    SetOverrideBinding(USQ.Frame, true, hotkey, "INTERACTTARGET")
                else
                    USQ.Debug(2, "Pets not damaged or above threshold, set macro to /targetexact [NPC].  Disable IWT and CTM.")
                    SetCVar("AutoInteract", 0)
                    ClearOverrideBindings(USQ.Frame)
                    USQ.SetMacro("/targetexact " .. BattleNPCName)
                    SetOverrideBindingClick(USQ.Frame, true, hotkey, "UltraSquirtButton")
                end
            end
        end
    end
end

function USQ:TargetNPCID()
    if UnitGUID("target") then
        return tonumber((select(6, strsplit("-", UnitGUID("target")))))
    end
end

function USQ:PetsHurt(threshold)
    USQ.Debug(2, "PetsHurt running.")

    threshold = threshold or 100

    USQ.Debug(2, "PetsHurt: threshold: " .. tostring(threshold))

    local petsHurt = false
    for i = 1, 3 do
        local petGUID, ability1, ability2, ability3, locked = C_PetJournal.GetPetLoadOutInfo(i)
        if petGUID then
            local health, maxHealth, power, speed, rarity = C_PetJournal.GetPetStats(petGUID)
            USQ.Debug(2, "PetsHurt: slot: " .. i .. " petGUID: " .. tostring(petGUID) .. " health: " .. tostring(health) .. " / " .. tostring(maxHealth))
        
            if threshold == 100 or not(maxHealth) or maxHealth <= 0 then
                petsHurt = (petsHurt or C_PetJournal.PetIsHurt(petGUID))
            else
                petsHurt = (petsHurt or (100 * health / maxHealth) < threshold)
            end
        end
        USQ.Debug(2, "PetsHurt: petsHurt: " .. tostring(petsHurt))
    end
    return petsHurt
end

function USQ:WaitForTimer(seconds)
    -- Pause any actions for a set period
    -- Flag is overridden when Rematch:LoadHealthiestOfLoadedPets (see hook function HookRematchLoadHealthiestOfLoadedPets)
    local TimeRemaining = USQ:TimeLeft(USQ.WaitTimer)
    if TimeRemaining > seconds then
        USQ.Debug(1, "WaitFlag timer already running, with " .. tostring(TimeRemaining) .. "s left.  Already covers new timer, so no action taken.")
        return
    elseif TimeRemaining > 0 then
        USQ.Debug(1, "WaitFlag timer already running, with " .. tostring(TimeRemaining) .. "s left.  Resetting to start new run.")
        USQ:CancelTimer(USQ.WaitTimer)
    end
    USQ.WaitFlag = true
    USQ.WaitTimer = USQ:ScheduleTimer(USQ.ClearWaitFlag, seconds)
    USQ.Debug(1, "WaitFlag set.  Time started for " .. tostring(seconds) .. "s.")
end

function USQ.ClearWaitFlag()
    -- Clear Wait Flag - only to be called by USQ:WaitForTimer
    if USQ.WaitFlag then
        USQ.Debug(1, "Clearing WaitFlag.")
    else
        USQ.Debug(1, "WaitFlag already cleared.")
    end
    USQ.WaitFlag = false
end

--Event Handlers
function USQ:PET_BATTLE_OPENING_START(eventName)
    USQ.EventHandler(eventName)
end

function USQ:PET_BATTLE_CLOSE(eventName)
    -- Wait after each battle for the UI to update.
    if Rematch and (Rematch:IsTimerRunning("ReloadLoadIn") or Rematch:IsTimerRunning("TeamlessReloadLoadIn")) then
        USQ.Debug(1, "Rematch ReloadLoadIn timer already running - no need for action.")
    elseif Rematch and RematchSettings and RematchSettings.LoadHealthiest and RematchSettings.LoadHealthiestAfterBattle then
        USQ.Debug(1, "Rematch ReloadLoadIn timer not running, LoadHealthiestAfterBattle enabled - wait up to " .. tostring(USQ.db.global.RematchLoadTeamDelay) .. " seconds.")
        --USQ:WaitForTimer(10)
        USQ:WaitForTimer(USQ.db.global.RematchLoadTeamDelay)
    else
        USQ.Debug(1, "Rematch ReloadLoadIn timer not running, LoadHealthiestAfterBattle disabled - wait up to " .. tostring(USQ.db.global.PetBattleCloseDelay) .. " seconds.")
        --USQ:WaitForTimer(1)
        USQ:WaitForTimer(USQ.db.global.PetBattleCloseDelay)
    end

    -- Rematch:LoadHealthiestOfLoadedPets is hooked in OnInitialize.  If it fires this flag will be set to false early, as Rematch will have either loaded or set a timer to load a new pet setup.

    -- Continue processing
    USQ.EventHandler(eventName)
end

function USQ:PET_JOURNAL_LIST_UPDATE(eventName)
    USQ.EventHandlet(eventName)
end

function USQ:GOSSIP_SHOW(eventName)
    USQ.Debug(2, "GOSSIP_SHOW triggered.")
    USQ.Update()
end

function USQ:PLAYER_REGEN_DISABLED(eventName)
    USQ.EventHandler(eventName)
end

function USQ:UNIT_SPELLCAST_SUCCEEDED(eventName, unitTarget, castGUID, spellID)
    --USQ.Debug(1, "UNIT_SPELLCAST_SUCCEEDED triggered: spellID: " .. tostring(spellID) .. ", spellName: " .. tostring(GetSpellInfo(spellID)) .. ".")
    if unitTarget == "player" and (spellID == 125439 or spellID == 133994) then
        USQ.Debug(1, "UNIT_SPELLCAST_SUCCEEDED triggered by player healing pets - wait up to " .. tostring(USQ.db.global.HealDelay) .. " seconds.")
        USQ:WaitForTimer(USQ.db.global.HealDelay)
        USQ.Update()
    end
end

-- Button Functions

function USQ.ItemButton_OnEvent(button, eventName, ...)
    USQ.ItemButton_UpdateCooldown(button)
    USQ.ItemButton_UpdateCount(button)
    USQ.ItemButton_UpdateState(button)
end

function USQ.ItemButton_UpdateCooldown(button)
    USQ.Debug(3, "Cooldown: " .. tostring(button:GetName()))
    USQ.Debug(3, "Cooldown: type1: " .. tostring(button:GetAttribute("type1")) .. " item: " .. tostring(button:GetAttribute("item")) .. " toy: " .. tostring(button:GetAttribute("toy")) .. " spell: " .. tostring(button:GetAttribute("spell")))
    local cooldown = button.cooldown
    local type1 = button:GetAttribute("type1")
    local start, duration, enable, modRate
    if type1 == "item" or type1 == "toy" then
        start, duration, enable = GetItemCooldown(button.actionID)
    elseif type1 == "spell" then
        start, duration, enable, modRate = GetSpellCooldown(button.actionID)
    end

    USQ.Debug(3, "Cooldown: start: " .. tostring(start) .. " duration: " .. tostring(duration) .. " enable: " .. tostring(enable) .. " modRate: " .. tostring(modRate))
    if (cooldown and start and duration) then
        if (enable) then
            cooldown:Hide()
        else
            cooldown:Show()
        end
        CooldownFrame_Set(cooldown, start, duration, enable, false, modRate)
    else
        cooldown:Hide()
    end
end

function USQ.ItemButton_UpdateCount(button)
    USQ.Debug(3, "Count: " .. tostring(button:GetName()))
    USQ.Debug(3, "Count: type1: " .. tostring(button:GetAttribute("type1")) .. " item: " .. tostring(button:GetAttribute("item")) .. " toy: " .. tostring(button:GetAttribute("toy")) .. " spell: " .. tostring(button:GetAttribute("spell")))
    local itemID = button:GetAttribute("item")
    local type1 = button:GetAttribute("type1")
    if type1 == "item" then
        local count = GetItemCount(itemID, false)
        USQ.Debug(3, "Count: updating count to: " .. tostring(count))
        button.count = count
        if count > 0 then
            button.Count:SetText(AbbreviateNumbers(count))
            button.Count:SetTextColor(HIGHLIGHT_FONT_COLOR:GetRGB())
            button.Count:Show()
        else
            button.Count:Hide()
        end
    else
        USQ.Debug(3, "Count: type1 is not item - nothing to do")
    end
end

function USQ.ItemButton_UpdateState(button)
    USQ.Debug(3, "UpdateState: button: " .. tostring(button:GetName()))
    if USQ.db.global[button.autoCastOption] then
        AutoCastShine_AutoCastStart(button.Shine)
    else
        AutoCastShine_AutoCastStop(button.Shine)
    end

    -- ???????? can the glow colour be changed to red when the count is zero??
    if GetItemSpell(button.actionID) and USQ.db.global[button.autoCastOption] == true and button.autoCastAllowed == false and AuraUtil.FindAuraByName((GetItemSpell(button.actionID)), "player") == nil then
        ActionButton_ShowOverlayGlow(button)
    else
        ActionButton_HideOverlayGlow(button)
    end
end

function USQ.ItemButton_OnClick(button, buttonClicked, down)
    USQ.Debug(1, "button: " .. tostring(button:GetName()) .. " buttonClicked: " .. tostring(buttonClicked) .. " down: " .. tostring(down))
    if buttonClicked == "RightButton" and button.isTogglable == true then
        USQ.db.global[button.autoCastOption] = not(USQ.db.global[button.autoCastOption])
    end
    USQ.ItemButton_UpdateState(button)
    USQ.Update()
end

function USQ.BandageHealPreClick(button, buttonClicked)
    USQ.Debug(1, "BandageHealPreClick: button: " .. tostring(button:GetName()) .. " buttonClicked: " .. tostring(buttonClicked))
    if not(USQ:PetsHurt(USQ.db.global.BattleHealingThreshold[USQ.BattleNPCID])) then
        USQ.Debug(1, "Pets not damaged, temporarily disabling button.")
        button:SetAttribute("type1", nil)
    end
end

function USQ.BandageHealPostClick(button, buttonClicked)
    USQ.Debug(1, "BandageHealPostClick: button: " .. tostring(button:GetName()) .. " buttonClicked: " .. tostring(buttonClicked))
    if button:GetAttribute("type1") == nil then
        USQ.Debug(1, "button.type1 is nil - resetting to: " .. tostring(button.type1))
        button:SetAttribute("type1", button.type1)
    else
        USQ.Debug(1, "button.type1 is not nil - no action")
    end
end